# fixcheck
This is the replication package for FixCheck, a tool for improving patch correctness analysis. This file contains the setup instructions and two simple examples. To perform the experiments follow the instructions in file ```experiments.md```

## Setup

### Requirements

- Java >= 1.8 (tested with 1.8)
- Python3 (tested with 3.10.10)
- Maven >= 3.8.6
- Ant >= 1.10.12
- Git >= 1.9

### Setup
1. Install the python requirements for bf4j:
```bash
cd bf4j
pip3 install -r requirements.txt
```
2. Download and install [defects4j](https://github.com/rjust/defects4j) (make sure the command defects4j is available)
3. Download the [DefectRepairing](https://github.com/Ultimanecat/DefectRepairing) benchmark
4. Define the following environment variables:
```bash
export BF4J_DATASET=path_to_bf4j
export DEFECT_REPAIRING_DATASET=path_to_defectrepairing
export FIXCHECK=path_to_fixcheck
```

## Example

Before running each example, ensure the `replit-code` model is up and running:
```bash
cd fixcheck
nohup python3 llms/replit-code.py &
```

### Example on BF4J

Example analysing the subject jackson-databind-118 from bf4j:
```bash
cd bf4j
python3 bad-fixes.py -o build -b jackson-databind-118
cd ../fixcheck
python3 experiments/run-fixcheck-bf4j.py jackson-databind-118 replit-code-llm
```

### Example on DefectRepairing

Example analysing a candidate patch from the [DefectRepairing](https://github.com/Ultimanecat/DefectRepairing) benchmark:
```bash
cd fixcheck
python3 experiments/setup-defect-repairing.py Patch1 replit-code-llm
python3 experiments/run-fixcheck-defect-repairing.py Patch1 replit-code-llm
```
