# bf4j: Bad Fixes for Java

This repository contains a collection of bad fixes from open-source Java projects.

## Dataset

### Projects

The dataset contains 41 bad fixes from the following 19 open-source projects:  

| Source    | Project               | Bad Fixes |
|-----------|-----------------------|----------:|
| Defects4J | [apache/commons-cli](https://github.com/apache/commons-cli) 	       |         3 |
| Defects4J | [apache/commons-csv](https://github.com/apache/commons-csv) |         1 |
| Defects4J | [apache/commons-jxpath](https://github.com/apache/commons-jxpath) |          2 |
| Defects4J | [apache/commons-lang](https://github.com/apache/commons-lang)        |         2 |
| Defects4J | [apache/commons-math](https://github.com/apache/commons-math)        |         6 |
| Defects4J | [FasterXML/jackson-databind](https://github.com/FasterXML/jackson-databind) |         5 |
| Defects4J | [google/closure-compiler](https://github.com/google/closure-compiler)    |         5 |
| Popular   | [apache/avro](https://github.com/apache/avro)                           |         1 |
| Popular   | [apache/commons-io](https://github.com/apache/commons-io)               |         2 |
| Popular   | [apache/mahout](https://github.com/apache/mahout)                       |         2 |
| Popular   | [ben-manes/caffeine](https://github.com/ben-manes/caffeine)             |         1 |
| Popular   | [ehcache/ehcache3](https://github.com/ehcache/ehcache3)                 |         1 |
| Popular   | [google/guava](https://github.com/google/guava)                         |         1 |
| Popular   | [graphhopper/graphhopper](https://github.com/graphhopper/graphhopper)   |         3 |
| Popular   | [immutables/immutables](https://github.com/immutables/immutables)       |         1 |
| Other     | [chocoteam/choco-solver](https://github.com/chocoteam/choco-solver)     |         1 |
| Other     | [gurkenlabs/litiengine](https://github.com/gurkenlabs/litiengine)       |         1 |
| Other     | [MenoData/Time4J](https://github.com/MenoData/Time4J)                   |         3 |

### Bad fixes

The folder ```data``` contains a folder for each bad fix. Each bad-fix folder contains the following files: 

- ```bad-fix.json```: contains the information of the corresponding bad fix.

## Setup

### Requirements

- Java 1.8
- Git >= 1.9 
- Maven >= 3.8.6
- Ant >= 1.10.12
- Python3

### Steps

1. Clone the repository:
   - `git clone https://github.com/facumolina/bf4j`
2. Install the python requirements:
   - `pip3 install -r requirements.txt`

## Usage

Example commands:

1. Get info of the whole dataset:
   - `python3 bad-fixes.py -o info`
2. Get info of a specific bad fix (math-1208)
   - `python3 bad-fixes.py -o info -b math-1208`
3. Build a specific bad fix (math-1208)
   - `python3 bad-fixes.py -o build -b math-1208`
