import argparse
import sys
from py_scripts.setup import setup_bad_fix
from py_scripts.info import get_info, get_formatted_info

# Parse the arguments
parser = argparse.ArgumentParser()
# Main argument
parser.add_argument("-o", "--option", help="Option (info, build)", choices=['info', 'build'],
                    required=True)
# Arguments for info and build options
parser.add_argument("-b", "--badfix", help="Bad fix subject (see data folder)")
parser.add_argument("-f", "--format", help="Output format (csv)", choices=['csv'])
parser.add_argument("-v", "--version", help="Version (buggy, badfix, fix)", choices=['buggy', 'badfix', 'fix'])

args = parser.parse_args()

print("--- BAD FIXES ---")
print("option: " + args.option)
bad_fix = args.badfix
if bad_fix:
    print("bad_fix: " + bad_fix)
version = args.version
print()

if args.option == "info":
    if args.format is None:
        get_info(bad_fix)
    else:
        get_formatted_info(bad_fix, args.format)

if args.option == "build":
    if args.badfix is None:
        print("bad-fixes.py: error: the following argument is required for build: -b/--badfix")
        sys.exit()
    version_to_build = 'all'
    if args.version is not None:
        version_to_build = args.version
    setup_bad_fix(bad_fix, version_to_build)

print("Done!")
