import argparse
import sys
from py_scripts.inspector.inspect import inspect_repository

"""
Inspector: allows to inspector a repository for issues/commits in order to search for potential bad fixes 
"""

# Parse the arguments
parser = argparse.ArgumentParser()
parser.add_argument("-s", "--source", help="Source for the issues", choices=['github', 'jira'], required=True)
parser.add_argument("-n", "--name", help="Name of the repository (apache/commons-lang)", required=True)
parser.add_argument("-k", "--key", help="Project key for jira (LANG)")
parser.add_argument("-u", "--url", help="Base url for jira projects (issues.apache.org)")

args = parser.parse_args()

print("--- INSPECTOR ---")
print("source: " + args.source)
print("name: " + args.name)

if args.source == "jira" and (args.key is None or args.url is None):
    print("inspector.py: error: key (-k/--key) and url (-u/--url) are required for inspecting jira projects")
    sys.exit()

inspect_repository(args.source, args.name, args.key, args.url)

print("Done!")
