# fixcheck experiments
This file contains the instructions to replicate the experiments in the paper. Before following these instructions, ensure you performed all the steps in the ```README.md``` file.
All the scripts below assume you are in the `fixcheck` folder. 

## Generating fixcheck output
First, note that the folder ```fixcheck-output``` already contains the output from which we compute the results in our paper.
To run fixcheck and generate the output again, every patch must be analysed. First, ensure that the `replit-code` model us up and running:
```bash
nohup python3 llms/replit-code.py &
```
To run fixcheck on the patches from the bf4j dataset,  run the following command:
```bash
python3 experiments/run-all-bf4j.py replit-code-llm
```
Then, to run it on the DefectRepairing patches, run:
```bash
python3 experiments/setup-all-defect-repairing.py
python3 experiments/run-all-defect-repairing.py replit-code-llm
```
This will produce the fixcheck output for each analysed patch in the folder ```fixcheck-output```.

## Results

### Effectiveness - RQ1.
To obtain the precision/recall results of the analysis performed in RQ1, run the following command:
```bash
python3 experiments/results/rq1-effectiveness.py replit-code-llm
```
### Complementing Patch Correctness Analysis Tools - RQ2.
To analyse how fixcheck can improve the output of PATCH-SIM and Shibboleth (the state-of-the-art patch correctness assessment tools), run the following comand:
```bash
python3 experiments/results/rq2-fixcheck-with-pca.py replit-code-llm
```
### Improvement with LLM-generated assertions - RQ3.
This RQ compares the performance of fixcheck using the LLM-assertions (replit-code-llm) with using no assertions and the previous assertions.
To obtain the results for **no-assertion**, run the following commands:
 ```bash
python3 experiments/results/rq1-effectiveness.py no-assertion
python3 experiments/results/rq2-fixcheck-with-pca.py no-assertion
```
To obtain the results for **previous-assertion**, run:
 ```bash
python3 experiments/results/rq1-effectiveness.py previous-assertion
python3 experiments/results/rq2-fixcheck-with-pca.py previous-assertion
```
### Efficiency - RQ4.
Finally, the results regarding the efficiency of our approach can be obtained with the following commands:
 ```bash
python3 experiments/results/rq4-efficiency.py replit-code-llm
```
