package com.fasterxml.jackson.databind.jsontype;

import java.util.Date;
import com.fasterxml.jackson.annotation.*;
import com.fasterxml.jackson.annotation.JsonTypeInfo.As;
import com.fasterxml.jackson.annotation.JsonTypeInfo.Id;
import com.fasterxml.jackson.databind.ObjectMapper;
import org.junit.Test;
import static org.junit.Assert.*;

// Tests for [JACKSON-453]
public class SimilarPrefixInputTransformer4 {

    public static class ExternalTypeWithNonPOJO {

        @JsonTypeInfo(use = JsonTypeInfo.Id.NAME, property = "type", visible = true, include = JsonTypeInfo.As.EXTERNAL_PROPERTY, defaultImpl = String.class)
        @JsonSubTypes({ @JsonSubTypes.Type(value = Date.class, name = "date"), @JsonSubTypes.Type(value = String.class, name = "") })
        public Object value;

        public ExternalTypeWithNonPOJO() {
        }

        public ExternalTypeWithNonPOJO(Object o) {
            value = o;
        }
    }

    // For [Issue#118]
    // Note: String works fine, since no type id will used; other scalar types have issues
    @Test
    public void testWithScalar118() throws Exception {
        ObjectMapper mapper = new ObjectMapper();
        ExternalTypeWithNonPOJO input = new ExternalTypeWithNonPOJO(new Integer(34));
        String json = mapper.writeValueAsString(input);
        // and back just to be sure:
        ExternalTypeWithNonPOJO result = mapper.readValue(json, ExternalTypeWithNonPOJO.class);
    }
}
